$hover-transition: 250ms;
$transform-transition: 300ms;

.j-resizer-container {
  position: relative;
  width: max-content;
}

.j-resizer {
  display: flex;
  position: absolute;
  z-index: 1;

  &.active, &:hover {
    .line {
      opacity: 1;
    }

    .j-resizer-btn {
      color: rgb(var(--j-primary-text-color));
      background-color: rgb(var(--j-primary-color));
    }
  }

  &.j-resizer-x {
    top: 0;
    right: calc(var(--resizer-size) * -1);
    bottom: 0;
    width: var(--resizer-size);
    cursor: ew-resize;

    .j-resizer-btn {
      top: 18px;
      right: 12px;
    }

    .line {
      left: -2px;
      width: 2px;
      height: 100%;
    }

    .strip {
      right: 24px;
      width: 3px;
      height: 100%;
      background: linear-gradient(
        to left,
        rgba(0, 0, 0, 0.2) 0px,
        rgba(0, 0, 0, 0.2) 1px,
        rgba(0, 0, 0, 0.1) 1px,
        rgba(0, 0, 0, 0) 100%
      );
    }

    :deep(.j-icon) {
      transition: transform $transform-transition;
      transform: rotate(90deg);
    }

    .j-min-resize {
      :deep(.j-icon) {
        transform: rotate(-90deg);
      }
    }
  }

  &.j-resizer-y {
    left: 0;
    right: 0;
    bottom: calc(var(--resizer-size) * -1);
    width: 100%;
    height: var(--resizer-size);
    cursor: n-resize;

    .j-resizer-btn {
      bottom: 13px;
      left: 18px;
    }

    .line {
      top: -2px;
      width: 100%;
      height: 2px;
    }

    .strip {
      bottom: 24px;
      width: 100%;
      height: 3px;
      background: linear-gradient(
        to top,
        rgba(0, 0, 0, 0.2) 0px,
        rgba(0, 0, 0, 0.2) 1px,
        rgba(0, 0, 0, 0.1) 1px,
        rgba(0, 0, 0, 0) 100%
      );
    }

    :deep(.j-icon) {
      transition: transform $transform-transition;
      transform: rotate(-180deg);
    }

    .j-min-resize {
      :deep(.j-icon) {
        transform: rotate(0);
      }
    }
  }

  &.j-resizer-xy {
    right: -7px;
    bottom: -7px;
    width: 24px;
    height: 24px;
    cursor: nw-resize;

    :deep(.j-icon) {
      transition: transform $transform-transition;
      transform: rotate(135deg);
    }

    .j-min-resize {
      :deep(.j-icon) {
        transform: rotate(-45deg);
      }
    }
  }
}

.line {
  position: absolute;
  opacity: 0;
  transition: $hover-transition;
  background: rgb(var(--j-primary-color));
}

.strip {
  position: absolute;
}

.j-resizer-btn {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
  z-index: 1;
  padding: 0;
  width: 24px;
  height: 24px;
  border-radius: 50%;
  cursor: unset;
  background-color: rgb(var(--j-primary-text-color));
  box-shadow: #091e4214 0 0 0 1px, #091e4214 0 2px 4px 1px;
  transition: $hover-transition;
}